#include <iostream>
#include <vector>

using namespace std;

int n;
vector<vector<int> > M;
vector<bool> visited;

// Dybde-foerst soek, returnerer lengste lengde i sub-treet den besoeker,
// og lengden til fjerneste node fra starten av sub-treet.
pair<int, int> visit(int node) {
  visited[node] = true;  // Marker at noden er besoekt.
  int maxSubDist = 0;  // Max lengde i sub-tre under denne
  int maxSubDepth = 0;  // Max dybde i sub-tre under denne
  int sumSubDist = 0;  // Sum av to dypeste sub-tre under denne, eller max lengde i sub-tre under denne.
  for (int i = 0; i < M[node].size(); ++i) {
    int next = M[node][i];
    if (!visited[next]) {
      pair<int, int> sub = visit(next);
      if (sub.second + maxSubDepth > sumSubDist) {
	sumSubDist = sub.second + maxSubDepth;
      }
      if (sub.first > maxSubDist) {
	maxSubDist = sub.first;
      }
      if (sub.second > maxSubDepth) {
	maxSubDepth = sub.second;
      }
    }
  }
  if (maxSubDist > sumSubDist) {
    sumSubDist = maxSubDist;
  }
  return make_pair<int, int>(sumSubDist, maxSubDepth + 1);
}

int main() {
  cin >> n;
  M.resize(n);
  visited.resize(n);
  int a, b;
  for (int i = 0; i < n - 1; ++i) {
    visited[i] = false;
    cin >> a >> b;
    M[a].push_back(b);
    M[b].push_back(a);
  }
  visited[n-1] = false;
  pair<int, int> ret = visit(0);
  int longest = ret.first;
  if (ret.second > ret.first) {
    longest = ret.second;
  }
  cout << (2 * (n - 1) - ret.first) << endl;
  return 0;
}
