#include<iostream>
#include<vector>
#include<cstring>

#define INF 2000000000
using namespace std;

// memo[a][b] = best energy where on platform a and all platform
// between a and b are depleted
long long memo[500][500];
// dist[a][b] = total energy cost of going from platform a to b
int dist[500][500];

int main(){
    int P;
    cin>>P;
    vector<int> start(P);
    vector<int> stopp(P);
    vector<int> val(P);
    for (int i=0;i<P;i++){
        cin>>start[i]>>stopp[i]>>val[i];
    }
    int A,E;
    cin>>A>>E;
    int curplat=-1;
    for (int i=0;i<P;i++){
        if (start[i]<=A && stopp[i]>=A){
            curplat=i;
            break;
        }
    }

    memset(memo,-1,sizeof(memo));
    memset(dist,INF,sizeof(dist));

    for (int i=0;i<P;i++){
        for (int j=0;i+j<P;j++){
            if (i==0) dist[j][j]=0;
            else
                dist[j][j+i]=dist[j+i][j]=dist[j][j+i-1]+start[j+i]-stopp[j+i-1];
        }
    }

    memo[curplat][curplat]=E+val[curplat];
    for (int i=1;i<P;i++){
        for (int j=0;i+j<P;j++){
            // find out best value of memo[j][j+i] and memo[j+i][j]
            // using memo[j+1][j+i] and memo[j+i-1][j] and optionally 
            // jumping from memo[j][j+i] to memo[j+i][j] or vice versa
            if (memo[j+1][j+i]>=dist[j][j+1]){
                memo[j][j+i] = max(memo[j][j+i],memo[j+1][j+i]-dist[j][j+1]+val[j]);
                if (memo[j][j+i]>=dist[j][j+i])
                    memo[j+i][j] = max(memo[j+i][j],memo[j][j+i]-dist[j][j+i]);
            }
            if (memo[j+i-1][j]>=dist[j+i-1][j+i]){
                memo[j+i][j] = max(memo[j+i][j],memo[j+i-1][j]-dist[j+i-1][j+i]+val[j+i]);
                if (memo[j+i][j]>=dist[j][j+i])
                    memo[j][j+i] = max(memo[j][j+i],memo[j+i][j]-dist[j][j+i]);
            }
        }
    }
    long long best=0;
    for (int i=0;i<P;i++){
        for (int j=0;j<P;j++){
            best = max(best,memo[i][j]);
        }
    }
    cout<<best<<endl;
}


